Index: django/contrib/gis/admin/options.py
===================================================================
--- django/contrib/gis/admin/options.py	(revision 13856)
+++ django/contrib/gis/admin/options.py	(working copy)
@@ -67,12 +67,28 @@
         in the `widget` attribute) using the settings from the attributes set
         in this class.
         """
-        is_collection = db_field.geom_type in ('MULTIPOINT', 'MULTILINESTRING', 'MULTIPOLYGON', 'GEOMETRYCOLLECTION')
-        if is_collection:
-            if db_field.geom_type == 'GEOMETRYCOLLECTION': collection_type = 'Any'
-            else: collection_type = OGRGeomType(db_field.geom_type.replace('MULTI', ''))
+
+        is_unknown = db_field.geom_type in ('GEOMETRY',)
+        if not is_unknown:
+            #If it is not generic, get the parameters from the db_field
+            is_collection = db_field.geom_type in ('MULTIPOINT', 'MULTILINESTRING', 'MULTIPOLYGON', 'GEOMETRYCOLLECTION')
+            if is_collection:
+                if db_field.geom_type == 'GEOMETRYCOLLECTION': collection_type = 'Any'
+                else: collection_type = OGRGeomType(db_field.geom_type.upper().replace('MULTI', ''))
+            else:
+                collection_type = 'None'
+            is_linestring = db_field.geom_type in ('LINESTRING', 'MULTILINESTRING')
+            is_polygon = db_field.geom_type in ('POLYGON', 'MULTIPOLYGON')
+            is_point = db_field.geom_type in ('POINT', 'MULTIPOINT')
+            geom_type = OGRGeomType(db_field.geom_type)
         else:
+            #If it is generic, set sensible defaults
+            is_collection = False
             collection_type = 'None'
+            is_linestring = False
+            is_polygon = False
+            is_point = False
+            geom_type = OGRGeomType('Unknown')
 
         class OLMap(self.widget):
             template = self.map_template
@@ -81,15 +97,16 @@
                       'default_lat' : self.default_lat,
                       'default_zoom' : self.default_zoom,
                       'display_wkt' : self.debug or self.display_wkt,
-                      'geom_type' : OGRGeomType(db_field.geom_type),
+                      'geom_type' : geom_type,
                       'field_name' : db_field.name,
+                      'is_unknown': is_unknown,
                       'is_collection' : is_collection,
                       'scrollable' : self.scrollable,
                       'layerswitcher' : self.layerswitcher,
                       'collection_type' : collection_type,
-                      'is_linestring' : db_field.geom_type in ('LINESTRING', 'MULTILINESTRING'),
-                      'is_polygon' : db_field.geom_type in ('POLYGON', 'MULTIPOLYGON'),
-                      'is_point' : db_field.geom_type in ('POINT', 'MULTIPOINT'),
+                      'is_linestring' : is_linestring,
+                      'is_polygon' : is_polygon,
+                      'is_point' : is_point,
                       'num_zoom' : self.num_zoom,
                       'max_zoom' : self.max_zoom,
                       'min_zoom' : self.min_zoom,
Index: django/contrib/gis/admin/widgets.py
===================================================================
--- django/contrib/gis/admin/widgets.py	(revision 13856)
+++ django/contrib/gis/admin/widgets.py	(working copy)
@@ -4,6 +4,7 @@
 from django.forms.widgets import Textarea
 from django.template import loader, Context
 from django.utils import translation
+from django.contrib.gis.gdal import OGRGeomType
 
 # Creating a template context that contains Django settings
 # values needed by admin map templates.
@@ -31,8 +32,7 @@
                 value = GEOSGeometry(value)
             except (GEOSException, ValueError):
                 value = None
-
-        if value and value.geom_type.upper() != self.geom_type:
+        if value and value.geom_type.upper() != self.geom_type and self.geom_type != 'GEOMETRY':
             value = None
 
         # Constructing the dictionary of the map options.
@@ -64,7 +64,30 @@
             # Setting the parameter WKT with that of the transformed
             # geometry.
             self.params['wkt'] = wkt
-
+            
+            # Check if the field is generic so the proper values are overriden
+            if self.params['is_unknown']:
+                 self.params['geom_type'] = OGRGeomType(value.geom_type)
+                 if value.geom_type.upper() == 'LINESTRING': 
+                     self.params['is_linestring'] = True
+                 elif value.geom_type.upper() == 'POLYGON': 
+                     self.params['is_polygon'] = True
+                 elif value.geom_type.upper() == 'POINT': 
+                     self.params['is_point'] = True
+                 elif value.geom_type.upper() in ('MULTIPOINT', 'MULTILINESTRING', 'MULTIPOLYGON', 'GEOMETRYCOLLECTION'):
+                     self.params['is_collection']=True
+                     if value.geom_type.upper() == 'GEOMETRYCOLLECTION':
+                         self.params['collection_type'] = 'Any'
+                     else:
+                         self.params['collection_type'] = OGRGeomType(value.geom_type.upper().replace('MULTI', ''))
+                         
+        else:
+             if self.params['is_unknown']:
+                 # If the geometry is unknown and the value is not set, make it as flexible as possible.
+                 self.params['geom_type'] = OGRGeomType('GEOMETRYCOLLECTION')
+                 self.params['is_collection']=True
+                 self.params['collection_type'] = 'Any'      
+            
         return loader.render_to_string(self.template, self.params,
                                        context_instance=geo_context)
 
